// File ERROR.C (used to build LIBWAV.A)
// Written by:
// Daniel W. Lewis (dlewis@scu.edu)
// Computer Engineering Department
// Santa Clara University
// Revised Jan 2, 2015

#include "libwav.h"

typedef struct PTR
	{
	struct PTR	*	next ;
	AUDIO		*	audio ;
	} POINTER ;

PRIVATE POINTER *pointers = NULL ;

void _AddPointer(AUDIO *audio)
	{
	POINTER *pointer = (POINTER *) malloc(sizeof(POINTER)) ;
	if (pointer == NULL) _Error("Insufficient memory") ;
	pointer->audio = audio ;
	pointer->next = pointers ;
	pointers = pointer ;
	}

void _DelPointer(AUDIO *audio)
	{
	POINTER *pointer, *previous ;

	previous = (POINTER *) &pointers ;
	for (pointer = pointers; pointer != NULL; pointer = pointer->next)
		{
		if (pointer->audio == audio)
				{
				previous->next = pointer->next ;
				free(pointer) ;
				return ;
				}
		previous = pointer ;
		}
	_Error("Invalid AUDIO pointer") ;
	}

void _ChkPointer(AUDIO *audio)
	{
	POINTER *pointer ;

	for (pointer = pointers; pointer != NULL; pointer = pointer->next)
		{
		if (pointer->audio == audio) return ;
		}

	_Error("Invalid AUDIO pointer") ;
	}

void _Error(char *format, ...)
	{
	va_list args ;
	
	fprintf(stderr, "\n") ;
	va_start(args, format) ;
	vfprintf(stderr, format, args) ;
	va_end(args) ;
	fprintf(stderr, "\n") ;
	exit(255) ;
	}
